#
# This file is part of FMSOLVR, a Fast Multipole Solver for MD.
#
# Copyright © 2019 Andreas Beckmann
#
# FMSOLVR is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation, either version 2.1
# of the License, or (at your option) any later version.
#
# FMSOLVR is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with FMSOLVR.  If not, see
# <https://www.gnu.org/licenses/>.
#
#!/usr/bin/perl

$prefix = "";
$out = "";
$want = 0;
$layers = -1;

$only = $ENV{"ONLY"};

print "# p\tws\tlayers\twhat\ttime\tins\tcyc\n";

while (<>)
{
        chomp;
	if (/^p=(\d+)  ws=(\d+)  (?:max)?layers=(\d+)/) {
		print "$prefix\t$layers$out\n" if $out;
		$prefix = "$1\t$2";
		$out = "";
		$layers = $3;
	} elsif (/^L_star_layer_sum/) {
	} elsif (/PAPI_L1_DCM/) {
	} elsif (/^effective layers=(\d+)/) {
		$layers = $1;
	} elsif (/^$only/) {
		$want = 1;
		$out .= "\t$only";
	} elsif (/^COUNTER.*per step: (.*)/) {
		$out .= "\t" . $1 if $want;
	} else {
		$want = 0;
	}
}
print "$prefix\t$layers$out\n" if $out;
