#
# This file is part of FMSOLVR, a Fast Multipole Solver for MD.
#
# Copyright © 2019 Andreas Beckmann
#
# FMSOLVR is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation, either version 2.1
# of the License, or (at your option) any later version.
#
# FMSOLVR is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with FMSOLVR.  If not, see
# <https://www.gnu.org/licenses/>.
#

PARSE		?= ../benchmark-lattice-zam904/latticetimings.pl
FILTER		?= | awk '{ if ($$1 < old) { print "" } old=$$1 } { print }'
EXTRADEPS	?= Makefile $(PARSE)

lt_Lstar_%.txt: latticetiming_%.out $(EXTRADEPS)
	ONLY='L_\*' $(PARSE) $< $(FILTER) > $@
lt_Ostar_%.txt: latticetiming_%.out $(EXTRADEPS)
	ONLY='O_\*' $(PARSE) $< $(FILTER) > $@
lt_tLi_%.txt: latticetiming_%.out $(EXTRADEPS)
	ONLY='tL_i' $(PARSE) $< $(FILTER) > $@
lt_Li_%.txt: latticetiming_%.out $(EXTRADEPS)
	ONLY='L_i' $(PARSE) $< $(FILTER) > $@
lt_SL_%.txt: latticetiming_%.out $(EXTRADEPS)
	ONLY='S_L' $(PARSE) $< $(FILTER) > $@

%.ws1.txt: %.txt
	awk '{ if ($$1 == "#" || $$2 == 1) { print } }' $< > $@

%.ws2.txt: %.txt
	awk '{ if ($$1 == "#" || $$2 == 2) { print } }' $< > $@

%.ws4.txt: %.txt
	awk '{ if ($$1 == "#" || $$2 == 4) { print } }' $< > $@

%.p50.txt: %.txt
	awk '{ if ($$1 == "#" || $$1 == 50) { print } }' $< > $@
