time=`echo ${time:-0}`
ins=`echo ${ins:-0}`
cyc=`echo ${cyc:-0}`

if (time) {
datacol=5
lbl="time"
refval=-1
refp=-1
ymax=4.5
}
if (ins) {
datacol=7
lbl="ins"
refval=-1
refp=-1
ymax=5.5
}
if (cyc) {
datacol=8
lbl="cyc"
refval=-1
refp=-1
ymax=4.5
}

set title "Lattice operator (double)"
set xlabel "p"
set ylabel "ws"
set zlabel lbl
set key top left Left reverse
set logscale z

zval(x) = column(datacol)

splot \
	"lt_Li_up.txt"			using 1:2:(zval(-1)) w lp title "L_i U", \
	"lt_Li_uplow.txt"		using 1:2:(zval(-1)) w lp title "L_i F", \
	"lt_Lstar_up.txt"		using 1:2:(zval(-1)) w lp title "L_* U", \
	"lt_Lstar_uplow.txt"		using 1:2:(zval(-1)) w lp title "L_* F", \
	"lt_Ostar_up.txt"		using 1:2:(zval(-1)) w lp title "O_* U", \
	"lt_Ostar_uplow.txt"		using 1:2:(zval(-1)) w lp title "O_* F", \
	"lt_SL_upper.txt"		using 1:2:(zval(-1)) w lp title "S_L U", \
	"lt_SL_uplow.txt"		using 1:2:(zval(-1)) w lp title "S_L F", \
	"nothing" notitle

pause -1

set term postscript enhanced color solid
set output "z_lt_3d_" . lbl . ".ps"
replot

quit

