time=`echo ${time:-0}`
ins=`echo ${ins:-0}`
cyc=`echo ${cyc:-0}`
normalized=`echo ${normalized:-1}`

if (time) {
datacol=5
lbl="time"
refval=-1
refp=-1
ymax=4.5
}
if (ins) {
datacol=7
lbl="ins"
refval=-1
refp=-1
ymax=5.5
}
if (cyc) {
datacol=8
lbl="cyc"
refval=-1
refp=-1
ymax=4.5
}


type = "double"
ws = 1

set title sprintf("Lattice operator (%s) ws=%d", type, ws)
set xlabel "p"
if (normalized) {
set ylabel "normalized " . lbl ." per inner loop iteration"
set yrange [0:]
#set yrange [0:ymax]
} else {
set ylabel lbl
set logscale y
}
set key top left reverse Left
set grid ytics

#instr(p) = 3.5*(p+1)**4 + 43*(p+1)**3 + 105*(p+1)**2 + 84*(p+1) + 75
#ref = refval / instr(refp)
#normalize(x, y) = y / instr(x) / ref

boxes = ((ws+1+ws)*(ws+1+ws))**3 - (ws+1+ws)**3
work(p) = ((p + 1) * (p + 2)) / 2
# normalize over inner loop iterations - the inner loop only runs for m+2 <= l <= p
# the "internal" p value used in the lattice operator is twice the "external p value"
normalize(x, y) = y / boxes / work(2 * x - 2)

if (normalized) {
yval(x) = normalize(column(1),column(datacol))
} else {
yval(x) = column(datacol)
}

plot \
	"lt_Lstar_uplow_dynlay_Bp_V387.ws1.txt"			using 1:(yval(-1)) w lp title "L_* V387", \
	"lt_Lstar_uplow_dynlay_Bp_Von.ws1.txt"			using 1:(yval(-1)) w lp title "L_* Von", \
	"lt_Lstar_uplow_dynlay_Bp_Von_FastND.ws1.txt"		using 1:(yval(-1)) w lp title "L_* Von fast ND", \
	"lt_Lstar_uplow_dynlay_Bp_Von_ND.ws1.txt"		using 1:(yval(-1)) w lp title "L_* Von ND", \
	"lt_Lstar_uplow_dynlay_Bp_Von_Flm_ND.ws1.txt"		using 1:(yval(-1)) w lp title "L_* Von Flm ND", \
	"lt_Lstar_uplow_dynlay_Bp_VLs.ws1.txt"			using 1:(yval(-1)) w lp title "L_* VLs", \
	"lt_Lstar_uplow_dynlay_Bp_VLs_ND.ws1.txt"		using 1:(yval(-1)) w lp title "L_* VLs ND", \
	"lt_Lstar_uplow_dynlay_Bp_VLs_Row_ND.ws1.txt"		using 1:(yval(-1)) w lp title "L_* VLs Row ND", \
	"lt_Lstar_uplow_dynlay_Bp_VLs_Row_Flm_ND.ws1.txt"	using 1:(yval(-1)) w lp title "L_* VLs Row fgh ND", \
	"lt_Lstar_uplow_dynlay_Bp_VLs_Row_Flm2_ND.ws1.txt"	using 1:(yval(-1)) w lp title "L_* VLs Row efgh ND", \
	"lt_Lstar_uplow_dynlay_Bp_VLs_Row_Flm3_ND.ws1.txt"	using 1:(yval(-1)) w lp title "L_* VLs Row efgh m0 ND", \
	"lt_Lstar_uplow_dynlay_Bp_VLs_Row_Flm5_ND.ws1.txt"	using 1:(yval(-1)) w lp title "L_* VLs Row efgh+ ND", \
	"lt_Lstar_uplow_dynlay_Bp_VLs_Row_Flm4_ND.ws1.txt"	using 1:(yval(-1)) w lp title "L_* VLs Row efgh+ m0 ND", \
	"lt_Lstar_uplow_dynlay_Bp_VLs_Row_Fefgh_Susi2_ND.ws1.txt"	using 1:(yval(-1)) w lp title "L_* VLs Row efgh+ SuSI2 ND", \
	"lt_Lstar_uplow_dynlay_Bp_VLs_Row_Fefgh_rowit_genacc_ND.ws1.txt"	using 1:(yval(-1)) w lp title "L_* VLs Row efgh+ ND rowit genacc", \
	"lt_Lstar_uplow_dynlay_Bp_VLs_Row_Fefgh_rowit_SuSI2_genacc_ND.ws1.txt"	using 1:(yval(-1)) w lp title "L_* VLs Row efgh+ ND rowit SuSI2 genacc", \
	"lt_Lstar_uplow_dynlay_Bp_VLs_Row_Fefgh_rowit_SuSI2_supacc_ND.ws1.txt"	using 1:(yval(-1)) w lp title "L_* VLs Row efgh+ ND rowit SuSI2 supacc", \
	"lt_Lstar_uplow_dynlay_Bp_VLs_Row_Fefgh_rowit_SuSI2_supacc_call_ND.ws1.txt"	using 1:(yval(-1)) w lp title "L_* VLs Row efgh+ ND rowit SuSI2 supacc call", \
	"lt_Lstar_uplow_dynlay_Bp_VLs_Row_Fefgh_rowit_SuSI2_supacc_call_pf_ND.ws1.txt"	using 1:(yval(-1)) w lp title "L_* VLs Row efgh+ ND rowit SuSI2 supacc call prefetch", \
	"lt_Lstar_uplow_dynlay_Bp_VLs_Row_Fefgh_rowit_SuSI2_supacc_call_pf3_ND.ws1.txt"	using 1:(yval(-1)) w lp title "L_* VLs Row efgh+ ND rowit SuSI2 supacc call prefetch3", \
	"lt_Lstar_uplow_dynlay_Bp_VLs_Row_Fefgh_rowit_SuSI2_supacc_call_pf3a_ND.ws1.txt"	using 1:(yval(-1)) w lp title "L_* VLs Row efgh+ ND rowit SuSI2 supacc call prefetch3", \
	"lt_Lstar_newlattice.ws1.txt"				using 1:(yval(-1)) w lp title "newlattice", \
	"nothing" notitle

pause -1

set term postscript enhanced color solid
set output "z_lt_Lstar_" . lbl . ".ps"
replot

quit

	"lt_Lstar_up.ws1.txt"				using 1:(yval(-1)) w lp title "L_* U", \
	"lt_Lstar_uplow.ws1.txt"			using 1:(yval(-1)) w lp title "L_* F", \
	"lt_Lstar_uplow_dynlay.ws1.txt"			using 1:(yval(-1)) w lp title "L_* FD", \
	"lt_Lstar_uplow_dynlay_Bp.ws1.txt"		using 1:(yval(-1)) w lp title "L_* FDB", \
	"lt_Lstar_uplow_dynlay_Bp_fast.ws1.txt"		using 1:(yval(-1)) w lp title "L_* FDBfast", \
	"lt_Lstar_uplow_dynlay_Bp_Vno2.ws1.txt"		using 1:(yval(-1)) w lp title "L_* FDB Vno noT", \
	"lt_Lstar_uplow_dynlay_Bp_Vno3.ws1.txt"		using 1:(yval(-1)) w lp title "L_* FDB Vno noT", \
	"lt_Lstar_uplow_dynlay_Bp_Vnoavx.ws1.txt"	using 1:(yval(-1)) w lp title "L_* FDB Vnoavx noT", \
	"lt_Lstar_uplow_dynlay_Bp_VLsold.ws1.txt"	using 1:(yval(-1)) w lp title "L_* FDB VLs", \

	"lt_Lstar_uplow_dynlay_Bp_Vno.ws1.txt"			using 1:(yval(-1)) w lp title "L_* Vno", \
