time=`echo ${time:-0}`
ins=`echo ${ins:-0}`
cyc=`echo ${cyc:-0}`

if (time) {
datacol=5
lbl="time"
refval=-1
refp=-1
ymax=4.5
}
if (ins) {
datacol=7
lbl="ins"
refval=-1
refp=-1
ymax=5.5
}
if (cyc) {
datacol=8
lbl="cyc"
refval=-1
refp=-1
ymax=4.5
}

set title "Lattice operator (double) ws=1"
set xlabel "p"
set ylabel "normalized " . lbl ." per inner loop iteration"
set ylabel lbl
set key top left reverse Left
set grid ytics
#set yrange [0:ymax]
set logscale y

instr(p) = 3.5*(p+1)**4 + 43*(p+1)**3 + 105*(p+1)**2 + 84*(p+1) + 75
ref = refval / instr(refp)
normalize(x, y) = y / instr(x) / ref

yval(x) = normalize(column(1),column(datacol))
yval(x) = column(datacol)


file="lt_Li_uplow_dynlay_Bp.txt"
f(x) = a*x**4 + b*x**3 + c*x**2 + d*x + e
fit f(x) file using 1:7 via a,b,c,d,e

file2="lt_Ostar_uplow.txt"
g(x) = f*x**2 + g*x + h
fit g(x) file2 using 1:7 via f,g,h

plot \
	"lt_Li_uplow.ws1.txt"		using 1:(yval(-1)) w lp title "L_i F", \
	"lt_Li_uplow_dynlay_Bp.ws1.txt"	using 1:(yval(-1)) w lp title "L_i FDB", \
	"lt_Ostar_uplow.ws1.txt"		using 1:(yval(-1)) w lp title "O_* F", \
	"nothing" notitle

pause -1

quit
