time=`echo ${time:-0}`
ins=`echo ${ins:-0}`
cyc=`echo ${cyc:-0}`

if (time) {
datacol=5
lbl="time"
refval=-1
refp=-1
ymax=4.5
}
if (ins) {
datacol=7
lbl="ins"
refval=-1
refp=-1
ymax=5.5
}
if (cyc) {
datacol=8
lbl="cyc"
refval=-1
refp=-1
ymax=4.5
}

set title "Lattice operator (double) p=50"
set xlabel "ws"
set ylabel "normalized " . lbl ." per inner loop iteration"
set ylabel lbl
set key top left Left reverse
set grid ytics
#set yrange [0:ymax]
set logscale y

instr(p) = 3.5*(p+1)**4 + 43*(p+1)**3 + 105*(p+1)**2 + 84*(p+1) + 75
ref = refval / instr(refp)
normalize(x, y) = y / instr(x) / ref

yval(x) = normalize(column(1),column(datacol))
yval(x) = column(datacol)

plot \
	"lt_Li_up.p50.txt"			using 2:(yval(-1)) w lp title "L_i U", \
	"lt_Li_uplow.p50.txt"			using 2:(yval(-1)) w lp title "L_i F", \
	"lt_Lstar_up.p50.txt"			using 2:(yval(-1)) w lp title "L_* U", \
	"lt_Lstar_uplow.p50.txt"		using 2:(yval(-1)) w lp title "L_* F", \
	"lt_Ostar_up.p50.txt"			using 2:(yval(-1)) w lp title "O_* U", \
	"lt_Ostar_uplow.p50.txt"		using 2:(yval(-1)) w lp title "O_* F", \
	"lt_SL_up.p50.txt"			using 2:(yval(-1)) w lp title "S_L U", \
	"lt_SL_uplow.p50.txt"			using 2:(yval(-1)) w lp title "S_L F", \
	"nothing" notitle

pause -1

set term postscript enhanced color solid
set output "z_lt_ws_" . lbl . ".ps"
replot

quit
