time=`echo ${time:-0}`
ins=`echo ${ins:-0}`
cyc=`echo ${cyc:-0}`

if (time) {
datacol=2
lbl="time"
refval=3.3881e+06
refp=49
ymax=4.5
}
if (ins) {
datacol=4
lbl="ins"
refval=2.75367e+07
refp=49
ymax=5.5
}
if (cyc) {
datacol=5
lbl="cyc"
refval=1.31785e+07
refp=49
ymax=4.5
}

set title "M2L double"
set xlabel "p"
set ylabel "normalized " . lbl ." per inner loop iteration"
set key top left
set grid ytics
set yrange [0:ymax]

instr(p) = 3.5*(p+1)**4 + 43*(p+1)**3 + 105*(p+1)**2 + 84*(p+1) + 75
ref = refval / instr(refp)
normalize(x, y) = y / instr(x) / ref

yval(x) = normalize(column(1),column(datacol))

plot \
	"zb_M2L_fortran.txt"			using 1:(normalize($1,column(datacol)*10**9)/8) w lp title "Fortran", \
	"zb_M2L_v1_opt_upper.txt"		using 1:(yval(-1)) w lp title "v1 OU", \
	"zb_M2L_v1_ref_upper.txt"		using 1:(yval(-1)) w lp title "v1 RU", \
	"zb_M2L_v1_opt_upper_fmath.txt"		using 1:(yval(-1)) w lp title "v1 fm OU", \
	"zb_M2L_v1_ref_upper_fmath.txt"		using 1:(yval(-1)) w lp title "v1 fm RU", \
	"zb_M2L_opt_full_nassert.txt"		using 1:(yval(-1)) w lp title "Ox", \
	"zb_M2L_ref_upper_nassert.txt"		using 1:(yval(-1)) w lp title "RU", \
	"zb_M2L_ref_full_nassert.txt"		using 1:(yval(-1)) w lp title "RF", \
	"zb_M2L_opt_full_nassert_fmath.txt"	using 1:(yval(-1)) w lp title "fm Ox", \
	"zb_M2L_ref_upper_nassert_fmath.txt"	using 1:(yval(-1)) w lp title "fm RU", \
	"zb_M2L_ref_full_nassert_fmath.txt"	using 1:(yval(-1)) w lp title "fm RF", \
	"zb_M2L_swi_upper_nassert_fmath.txt"	using 1:(yval(-1)) w lp title "fm SU", \
	"zb_M2L_swi_full_nassert_fmath.txt"	using 1:(yval(-1)) w lp title "fm SF", \
	"nothing" notitle

pause -1

set term postscript enhanced color solid
set output "zb_M2L_" . lbl . ".ps"
replot

quit

	"zb_M2L_opt_upper_assert.txt"		using 1:(yval(-1)) w lp title "OUA", \
	"zb_M2L_opt_full_assert.txt"		using 1:(yval(-1)) w lp title "OFA", \
	"zb_M2L_ref_upper_assert.txt"		using 1:(yval(-1)) w lp title "RUA", \
	"zb_M2L_ref_full_assert.txt"		using 1:(yval(-1)) w lp title "RFA", \

	"zb_M2L_opt_upper_nassert.txt"		using 1:(yval(-1)) w lp title "OU", \
	"zb_M2L_opt_upper_nassert_fmath.txt"	using 1:(yval(-1)) w lp title "fm OU", \
