time=`echo ${time:-0}`
ins=`echo ${ins:-0}`
cyc=`echo ${cyc:-0}`
normalized=`echo ${normalized:-1}`

if (time) {
datacol=5
lbl="time"
unit=" [ns]"
ymax=4.5
}
if (ins) {
datacol=7
lbl="ins"
unit=""
ymax=5.5
}
if (cyc) {
datacol=8
lbl="cyc"
unit=""
ymax=4.5
}


type = "double"
ws = 4
prefix = "lt_"
suffix = sprintf(".ws%d.txt", ws)

set title sprintf("O_* operator (%s) ws=%d", type, ws)
set xlabel "p"
if (normalized) {
set ylabel "normalized " . lbl . unit . " per inner loop iteration"
set yrange [0:]
#set yrange [0:ymax]
} else {
set ylabel lbl . unit
set logscale y
}
set key top left reverse Left
set grid ytics

boxes = (ws+1+ws)**3
work(p) = ((p + 1) * (p + 2)) / 2
# normalize over inner loop iterations - the inner loop only runs for m+2 <= l <= p
# the "internal" p value used in the lattice operator is twice the "external" p value
normalize(x, y) = y / boxes / work(2 * x - 2)

if (normalized) {
yval(x) = normalize(column(1),column(datacol))
} else {
yval(x) = column(datacol)
}

plot \
	prefix."Ostar_rangecheck_387".suffix				using 1:(yval(-1)) w lp title "O_* rangecheck 387", \
	prefix."Ostar_rangecheck_base".suffix				using 1:(yval(-1)) w lp title "O_* rangecheck base", \
	prefix."Ostar_387".suffix					using 1:(yval(-1)) w lp title "O_* 387", \
	prefix."Ostar_base".suffix					using 1:(yval(-1)) w lp title "O_* base", \
	prefix."Ostar_R".suffix						using 1:(yval(-1)) w lp title "O_* Row", \
	prefix."Ostar_R_delaycomplex".suffix				using 1:(yval(-1)) w lp title "O_* Row delaycomplex", \
	prefix."Ostar_R_def".suffix					using 1:(yval(-1)) w lp title "O_* Row delaycomplex ef", \
	prefix."Ostar_R_def_lut".suffix					using 1:(yval(-1)) w lp title "O_* Row delaycomplex ef lut", \
	prefix."Ostar_RVsse".suffix					using 1:(yval(-1)) w lp title "O_* RV sse div2", \
	prefix."Ostar_RV_sse_scaldiv".suffix				using 1:(yval(-1)) w lp title "O_* RV sse div1", \
	prefix."Ostar_RV".suffix					using 1:(yval(-1)) w lp title "O_* RV avx div4", \
	prefix."Ostar_RV_avx_scaldiv".suffix				using 1:(yval(-1)) w lp title "O_* RV avx div1", \
	prefix."Ostar_RV_avx_def_lut1".suffix				using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1", \
	prefix."Ostar_RV_avx_def_lut4".suffix				using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut4", \
	prefix."Ostar_RV_avx_def_lut4_call".suffix			using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut4 call", \
	prefix."Ostar_RV_avx_def_lut4_call_olin2".suffix		using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut4 call Olin", \
	prefix."Ostar_RV_avx_def_lut4_call_olinptr".suffix		using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut4 call Olin ptr", \
	prefix."Ostar_RV_avx_def_lut1_call_olinptr".suffix		using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call Olin ptr", \
	prefix."Ostar_RV_avx_def_lut1_call_olinptr_susi2a".suffix	using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call Olin ptr SuSI2", \
	prefix."Ostar_RV_avx_def_lut1_call_olinptr_susi2b".suffix	using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call Olin ptr SuSI2", \
	prefix."Ostar_RV_avx_def_lut1_call_olinptr_susi2c".suffix	using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call Olin ptr SuSI2", \
	prefix."Ostar_RV_avx_def_lut1_call_susi2".suffix		using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call SuSI2", \
	prefix."Ostar_RV_avx_def_lut1_call_susi2_genacc".suffix		using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call SuSI2 genacc", \
	prefix."Ostar_RV_avx_def_lut1_call_susi2_supacc".suffix		using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call SuSI2 supacc", \
	prefix."Ostar_RV_avx_def_lut1_call_susi2_sclacc".suffix		using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call SuSI2 sclacc", \
	prefix."Ostar_RV_avx_def_lut1_call_susi2_sclacc2".suffix	using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call SuSI2 sclacc sumpair", \
	prefix."Ostar_RV_avx_def_lut1_call_susi2_sclacc3".suffix	using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call SuSI2 sclacc sumpair accm128d", \
	prefix."Ostar_RV_avx_def_lut1_call_susi2_sclacc4".suffix	using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call SuSI2 sclacc sumpairm128d", \
	prefix."Ostar_RV_avx_def_lut1_call_susi2_sclacc5".suffix	using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call SuSI2 sclacc sumpair", \
	prefix."Ostar_RV_avx_def_lut1_call_rowit".suffix		using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call rowit", \
	prefix."Ostar_RV_avx_def_lut1_call_susi2_rowit".suffix		using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call SuSI2 rowit", \
	prefix."Ostar_RV_avx_def_lut1_call_susi2_rowit_supacc".suffix	using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call SuSI2 rowit supacc", \
	prefix."Ostar_RV_avx_def_lut1_call_susi2_rowit_supacc3".suffix	using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call SuSI2 rowit supacc3", \
	prefix."Ostar_RV_avx_def_lut1_call_susi2_rowit_itlacc0".suffix	using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call SuSI2 rowit itlacc incorrect", \
	prefix."Ostar_RV_avx_def_lut1_call_susi2_rowit_sclacc".suffix	using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call SuSI2 rowit sclacc sumpair m128d", \
	prefix."Ostar_RV_avx_def_lut1_call_susi2_rowit_supacc_pf3".suffix	using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call SuSI2 rowit supacc prefetch3", \
	"nothing" notitle

pause -1

set term postscript enhanced color solid
set output "zz_lt_Ostar_" . lbl . ".ps"
replot

quit

	prefix."Ostar_RV_avx_def_lut1_call_olinptr_susi2".suffix	using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call Olin ptr SuSI2 notflat", \
	prefix."Ostar_RV_avx_def_lut1_call_susi2_rowit_supacc2".suffix	using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call SuSI2 rowit supacc", \
	prefix."Ostar_RV_avx_def_lut1_call_susi2_supacc2".suffix	using 1:(yval(-1)) w lp title "O_* RV avx delaycomplex ef lut1 call SuSI2 supacc2", \
