#
# This file is part of FMSOLVR, a Fast Multipole Solver for MD.
#
# Copyright © 2019 Andreas Beckmann
#
# FMSOLVR is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation, either version 2.1
# of the License, or (at your option) any later version.
#
# FMSOLVR is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with FMSOLVR.  If not, see
# <https://www.gnu.org/licenses/>.
#
CXX_CLANG		?= clang++

clang_version		:= $(shell echo '100 * __clang_major__ + 10 * __clang_minor__ + __clang_patchlevel__' | $(CXX_CLANG) -E - | grep -v ^\# | bc)

ifneq (,$(shell test $(clang_version) -ge 370 && echo HAS_OPENMP))
HAS_OPENMP		?= 1
OPENMP_FLAG		?= -fopenmp=libiomp5
endif

HAS_OPENMP		?=
HAS_STD_THREAD		?= 1
COMPILER_HAS_BOOST	?= 1

CXX			 = $(CXX_CLANG)

