/*
 * This file is part of FMSOLVR, a Fast Multipole Solver for MD.
 *
 * Copyright © 2019 Andreas Beckmann
 *
 * FMSOLVR is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 2.1
 * of the License, or (at your option) any later version.
 *
 * FMSOLVR is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with FMSOLVR.  If not, see
 * <https://www.gnu.org/licenses/>.
 */
#ifndef _AnBe_FMM_bulk_ops_impl_hpp_
#define _AnBe_FMM_bulk_ops_impl_hpp_

#include "bulk_ops.hpp"
#include "fmsolvr/operator/p3/multipole2local_p3_impl.hpp"
#include "fmsolvr/simd/simd_engine.hpp"


namespace fmsolvr {

namespace bulk {

template <typename RAIterator, typename Scratch>
void M2Lp3(RAIterator first, RAIterator last, size_t p, Scratch &scratch)
{
    for (RAIterator it = first; it != last; ++it) {
        M2Lp3_impl_folded<simd_engine_none>(it->in(), it->R(), it->Op(), it->out(), p, scratch);
    }

}

}  // namespace bulk

}  // namespace fmsolvr

#endif
// vim: et:ts=4:sw=4
