/*
 * This file is part of FMSOLVR, a Fast Multipole Solver for MD.
 *
 * Copyright © 2019 Andreas Beckmann
 *
 * FMSOLVR is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 2.1
 * of the License, or (at your option) any later version.
 *
 * FMSOLVR is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with FMSOLVR.  If not, see
 * <https://www.gnu.org/licenses/>.
 */
#include "fmm_enum.hpp"

std::ostream &operator<<(std::ostream &os, fmsolvr::FMMActivity a)
{
    switch (a)
    {
        case FMMActivity::EMPTY:
            os << "EMPTY";
            break;
        case FMMActivity::P2M:
            os << "P2M";
            break;
        case FMMActivity::M2M:
            os << "M2M";
            break;
        case FMMActivity::M2L:
            os << "M2L";
            break;
        case FMMActivity::L2L:
            os << "L2L";
            break;
        case FMMActivity::Lattice:
            os << "Lattice";
            break;
        case FMMActivity::L2P:
            os << "L2P";
            break;
        case FMMActivity::P2P:
            os << "P2P";
            break;
        case FMMActivity::STEAL:
            os << "STEAL";
            break;
        case FMMActivity::TRY_STEAL:
            os << "TRY_STEAL";
            break;
        case FMMActivity::_last_enum:
            os << "LAST";
            break;
        default:
            os << "UNDEFINED";
            break;
    }
    return os;
}

// vim: et:ts=4:sw=4
