/*
 * This file is part of FMSOLVR, a Fast Multipole Solver for MD.
 *
 * Copyright © 2019 Andreas Beckmann
 *
 * FMSOLVR is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 2.1
 * of the License, or (at your option) any later version.
 *
 * FMSOLVR is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with FMSOLVR.  If not, see
 * <https://www.gnu.org/licenses/>.
 */

#ifndef FMSOLVR_default_alloc_hpp
#define FMSOLVR_default_alloc_hpp

#include <memory>
#ifdef WITH_BOOST
//#include <boost/pool/pool_alloc.hpp>
#include "fmsolvr/util/boost_pool_alloc_11.hpp"
#endif


namespace fmsolvr {

template <typename Tp>
class default_allocator
{
public:
#ifndef USE_POOL_ALLOCATOR
    typedef std::allocator<Tp> type;
#else
    typedef boost::fast_pool_allocator<Tp> type;
#endif
};

}  // namespace fmsolvr

#endif
// vim: et:ts=4:sw=4
