/*
 * This file is part of FMSOLVR, a Fast Multipole Solver for MD.
 *
 * Copyright © 2019 Andreas Beckmann
 *
 * FMSOLVR is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 2.1
 * of the License, or (at your option) any later version.
 *
 * FMSOLVR is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with FMSOLVR.  If not, see
 * <https://www.gnu.org/licenses/>.
 */

#ifndef FMSOLVR_fmm_enum_hpp
#define FMSOLVR_fmm_enum_hpp

#include <ostream>


namespace fmsolvr
{

enum class FMMActivity
{
    UNDEFINED,
    EMPTY,
    P2M,
    M2M,
    M2L,
    Lattice,
    L2L,
    L2P,
    P2P,
    Dipole,
    STEAL,
    TRY_STEAL,
    _last_enum
};

std::ostream &operator<<(std::ostream &os, FMMActivity a);

}  // namespace fmsolvr

#endif
// vim: et:ts=4:sw=4
