/*
 * This file is part of FMSOLVR, a Fast Multipole Solver for MD.
 *
 * Copyright © 2019 Andreas Beckmann
 *
 * FMSOLVR is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 2.1
 * of the License, or (at your option) any later version.
 *
 * FMSOLVR is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with FMSOLVR.  If not, see
 * <https://www.gnu.org/licenses/>.
 */

#ifndef FMSOLVR_MATH_angle_hpp
#define FMSOLVR_MATH_angle_hpp

namespace fmsolvr
{

// Utility class to represent angles given by their cosine and sine.
template <typename Real>
class Angle
{
public:
    typedef Real value_type;

    Angle(value_type cos, value_type sin) : cos_(cos), sin_(sin)
    { }

    const value_type cos() const
    { return cos_; }

    const value_type sin() const
    { return sin_; }

private:
    value_type cos_, sin_;
};

}  // namespace fmsolvr

#endif
// vim: et:ts=4:sw=4
