/*
 * This file is part of FMSOLVR, a Fast Multipole Solver for MD.
 *
 * Copyright © 2019 Andreas Beckmann
 *
 * FMSOLVR is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 2.1
 * of the License, or (at your option) any later version.
 *
 * FMSOLVR is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with FMSOLVR.  If not, see
 * <https://www.gnu.org/licenses/>.
 */

#ifndef FMSOLVR_MATH_reciprocal_hpp
#define FMSOLVR_MATH_reciprocal_hpp

#include "fmsolvr/simd/Vec.hpp"

namespace fmsolvr
{

template <typename Real>
inline Real reciprocal(Real a)
{
    Vec_traits<Real> VT;
    return VT.same(1) / a;
}

}  // namespace fmsolvr

#endif
// vim: et:ts=4:sw=4
