/*
 * This file is part of FMSOLVR, a Fast Multipole Solver for MD.
 *
 * Copyright © 2019 Andreas Beckmann
 *
 * FMSOLVR is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 2.1
 * of the License, or (at your option) any later version.
 *
 * FMSOLVR is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with FMSOLVR.  If not, see
 * <https://www.gnu.org/licenses/>.
 */

#ifndef FMSOLVR_SIMD_Vec_config_hpp
#define FMSOLVR_SIMD_Vec_config_hpp

#if defined(__SSE__)
#define FMSOLVR_HAVE_SSE 1
#endif

#if defined(__SSE2__)
#define FMSOLVR_HAVE_SSE2 1
#endif

#if defined(__AVX__)
#define FMSOLVR_HAVE_AVX 1
#endif

#if defined(__AVX512F__)
#define FMSOLVR_HAVE_AVX512F 1
#endif

#endif
// vim: et:ts=4:sw=4
