/*
 * This file is part of FMSOLVR, a Fast Multipole Solver for MD.
 *
 * Copyright © 2019 Andreas Beckmann
 *
 * FMSOLVR is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 2.1
 * of the License, or (at your option) any later version.
 *
 * FMSOLVR is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with FMSOLVR.  If not, see
 * <https://www.gnu.org/licenses/>.
 */
#ifndef FMSOLVR_stackedmultireal_hpp
#define FMSOLVR_stackedmultireal_hpp

#include "fmsolvr/xyz.hpp"
#include "fmsolvr/xyzs.hpp"


namespace fmsolvr {

// the simplest StackedReal is a plain Real
template <typename StackedReal>
struct StackedMultiReal
{
    typedef StackedReal stacked_real_type;
    typedef XYZ<stacked_real_type> stacked_real3_type;
    typedef XYZS<stacked_real_type> stacked_real4_type;
    // typedef some::complex<stacked_real_type> stacked_complex_type;
};

}  // namespace fmsolvr

#endif
// vim: et:ts=4:sw=4
