#ifndef _DaHa_DependencyCounterDetails_
#define _DaHa_DependencyCounterDetails_

#include <tuple>
#include <type_traits>

#include "EventDispatcher/EventDispatcherEnumerations.hpp"

namespace dependency_counter
{
namespace details
{

template <Events event, typename TupleT, int current = 0>
static constexpr typename std::enable_if<current == std::tuple_size<TupleT>::value, int>::type
counter_pos()
{
    return current;
}

template <Events event, typename TupleT, int current = 0>
static constexpr typename std::enable_if<current != std::tuple_size<TupleT>::value, int>::type
counter_pos()
{
    return (event == std::tuple_element<current, TupleT>::type::EVENT)
                   ? current
                   : counter_pos<event, TupleT, current + 1>();
}
template <Events event, typename WrappedTupleT>
typename std::tuple_element<
        counter_pos<event, typename WrappedTupleT::wrapped_type>(),
        typename WrappedTupleT::wrapped_type>::type &
get_counter(WrappedTupleT &tuple)
{
    return std::get<counter_pos<event, typename WrappedTupleT::wrapped_type>()>(tuple);
}


}  // namespace details

}  // namespace dependency_counter

#endif
