#ifndef _DaHa_SpinLock_
#define _DaHa_SpinLock_

#include <atomic>

// Lock should be aligned to avoid false sharing
class alignas(64) SpinLock
{
public:
    SpinLock() = default;
    SpinLock(const SpinLock &) = delete;
    SpinLock(SpinLock &&) = delete;
    SpinLock &operator=(const SpinLock &) = delete;
    SpinLock &operator=(SpinLock &&) = delete;

    virtual ~SpinLock() = default;

    void lock()
    {
        while (state_.test_and_set())
        {
            // spin
        }
    }

    void unlock()
    {
        state_.clear();
    }

private:
    std::atomic_flag state_ = ATOMIC_FLAG_INIT;
};
#endif  // _DaHa_SpinLock_
