#ifndef _DaHa_MutexContainer_
#define _DaHa_MutexContainer_

#include <vector>

#include "Locks/MCSLock.hpp"
#include "ObjectAccessProvider.hpp"
#include "ObjectWrapper.hpp"
#include "fmsolvr/tree/denseoctree.hpp"

template <typename lock_type, typename fmm_handle_type>
class MutexContainer
{
    using object_access_strategy = LockStrategy<lock_type>;

    using ow_tree_type = fmsolvr::OctreeStorageDense<ObjectWrapper<
            typename fmm_handle_type::local_coefficients_type,
            object_access_strategy>>;

public:
    explicit MutexContainer(fmm_handle_type &fmm_handle)
            : lowest_lvl_particle_mutexes_(fmm_handle.particle_handle().num_boxes_lowest()),
              tree_ow_(fmm_handle.depth(), fmm_handle.tree_mu())
    {
    }


    std::vector<lock_type> lowest_lvl_particle_mutexes_;
    ow_tree_type tree_ow_;
};

#endif
