#ifndef _DaHa_ObjectAccess_
#define _DaHa_ObjectAccess_

#include <cstddef>
#include <functional>

#include "ObjectAccessStrategy.hpp"

template <typename ObjectType, typename ObjectAccessStrategy>
class ObjectAccessProvider;

template <typename ObjectType, typename ObjectAccessStrategy>
class ObjectAccess
{
};

template <typename ObjectType, typename LockType>
class ObjectAccess<ObjectType, LockStrategy<LockType>>
{
public:
    ObjectAccess(ObjectType &o, ObjectAccessProvider<ObjectType, LockStrategy<LockType>> &oap)
            : obj_(o), oap_(oap){};

    ~ObjectAccess()
    {
        oap_.ReleaseLock();
    }

    ObjectType &Obj() const
    {
        return obj_;
    }

private:
    ObjectType &obj_;
    ObjectAccessProvider<ObjectType, LockStrategy<LockType>> &oap_;
};

#endif
