#ifndef _DaHa_ObjectAccessProvider_
#define _DaHa_ObjectAccessProvider_

#include <atomic>
#include <iostream>
#include <mutex>

#include "ObjectAccess.hpp"
#include "ObjectAccessStrategy.hpp"


template <typename ObjectType, typename ObjectAccessStrategy>
class ObjectAccessProvider
{
};

template <typename ObjectType, typename  LockType>
class ObjectAccessProvider<ObjectType, LockStrategy<LockType>>
{
public:
    using object_type = ObjectType;
    using object_access_strategy = LockStrategy<LockType>;
    using object_access_type = ObjectAccess<object_type, object_access_strategy>;

    const object_access_type GetObjectAccess(object_type &obj)
    {
        lock_.lock();
        return object_access_type(obj, *this);
    }

    void ReleaseLock()
    {
        lock_.unlock();
    }

private:
    LockType lock_;
};

#endif
