#ifndef _DaHa_ThreadDormitory_hpp_
#define _DaHa_ThreadDormitory_hpp_

#include <condition_variable>
#include <mutex>

class ThreadDormitory
{
public:
    void trySleep()
    {
        if(soft_sleep) {
            std::unique_lock<std::mutex> unique_lock_guard(mutex);
            cv.wait(unique_lock_guard, [&]() { return !soft_sleep; });
        }
    }

    void putToSleepAll()
    {
        std::lock_guard<std::mutex> lock(mutex);
        soft_sleep = true;
    }

    void wakeUpAll()
    {
        {
            std::lock_guard<std::mutex> lock(mutex);
            soft_sleep = false;
        }
        cv.notify_all();
    }
private:
    bool soft_sleep = false;
    std::mutex mutex;
    std::condition_variable cv;
};


#endif
