#ifndef _DaHa_ThreadIdentifier_
#define _DaHa_ThreadIdentifier_

#include <iostream>

class ThreadIdentifier
{
public:
    explicit ThreadIdentifier(size_t thread_id) : id(thread_id), _initialized(true)
    {
    }
    ThreadIdentifier() = default;
    ThreadIdentifier(const ThreadIdentifier &other_thread_id) = default;
    ThreadIdentifier(ThreadIdentifier &&other_thread_id) = default;
    ThreadIdentifier &operator=(const ThreadIdentifier &other_thread_id) = default;
    ThreadIdentifier &operator=(ThreadIdentifier &&other_thread_id) = default;
    ~ThreadIdentifier() = default;

    size_t ID() const
    {
        return id;
    }

    bool isValid() const
    {
        return _initialized;
    }

private:
    size_t id{0};
    bool _initialized = false;

    friend std::ostream &operator<<(std::ostream &os, ThreadIdentifier const &tid);
};

inline std::ostream &operator<<(std::ostream &os, ThreadIdentifier const &tid)
{
    return os << "ThreadIdentifier - id: " << tid.id;
}

extern thread_local ThreadIdentifier _THIS_THREAD;

#endif
