#!/usr/bin/perl -w
#
# This file is part of FMSOLVR, a Fast Multipole Solver for MD.
#
# Copyright © 2019 Andreas Beckmann
#
# FMSOLVR is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation, either version 2.1
# of the License, or (at your option) any later version.
#
# FMSOLVR is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with FMSOLVR.  If not, see
# <https://www.gnu.org/licenses/>.
#

my (@q, @x, @y, @z);
while (<>) {
	my ($q, $x, $y, $z) = split;
	push @q, $q;
	push @x, $x;
	push @y, $y;
	push @z, $z;
}

sub print_array($@)
{
	my $var = shift;
	print "const double ${var}[" . scalar @_ ."] = {\n\t" . join(",\n\t", @_) . "\n\t};\n";
}

print "const int n = " . scalar @x . ";\n";
print_array("x", @x);
print_array("y", @y);
print_array("z", @z);
print_array("q", @q);
