#!/usr/bin/python
#
# This file is part of FMSOLVR, a Fast Multipole Solver for MD.
#
# Copyright © 2019 Andreas Beckmann
#
# FMSOLVR is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation, either version 2.1
# of the License, or (at your option) any later version.
#
# FMSOLVR is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with FMSOLVR.  If not, see
# <https://www.gnu.org/licenses/>.
#

import sys;
import random;

def main():
	if len(sys.argv) > 1:
		n = int(sys.argv[1])
	else:
		n = 10
	if len(sys.argv) > 2:
		q = int(sys.argv[2])
	else:
		q = 0
	for i in range(n):
		print "%15.12f %.12f %.12f %.12f" % (q * (random.random() - 0.5) * 2, random.random(), random.random(), random.random())


if __name__ == "__main__":
	main()
