#ifndef _DaHa_tuple_helper_
#define _DaHa_tuple_helper_

#include <tuple>

template <typename ElementT, typename TupleT, int current = 0>
static constexpr typename std::enable_if<current == std::tuple_size<TupleT>::value, int>::type
tuple_pos()
{
    return 0;
}

template <typename ElementT, typename TupleT, int current = 0>
static constexpr typename std::enable_if<current != std::tuple_size<TupleT>::value, int>::type
tuple_pos()
{
    return std::is_same<ElementT, typename std::tuple_element<current, TupleT>::type>::value
                   ? current
                   : tuple_pos<ElementT, TupleT, current + 1>();
}


#endif
