/*
 * This file is part of FMSOLVR, a Fast Multipole Solver for MD.
 *
 * Copyright © 2019 Andreas Beckmann
 *
 * FMSOLVR is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 2.1
 * of the License, or (at your option) any later version.
 *
 * FMSOLVR is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with FMSOLVR.  If not, see
 * <https://www.gnu.org/licenses/>.
 */
#include <gtest/gtest.h>

#include "fmsolvr/math/linear_algebra.hpp"

TEST(LinearAlgebraTests, CheckDeterminant) {
    fmsolvr::linear_algebra::SqMatrix<int> A(3);
    A[0][0] = 2;
    A[0][1] = 3;
    A[0][2] = 5;
    A[1][0] = 7;
    A[1][1] = 11;
    A[1][2] = 13;
    A[2][0] = 17;
    A[2][1] = 19;
    A[2][2] = 23;

    int detA = fmsolvr::linear_algebra::det(3, A);
    ASSERT_EQ(detA, -78);
}
// vim: et:ts=4:sw=4
