#include <gtest/gtest.h>

#if 0
#include "parallelization/ObjectAccessWrapper.hpp"
#include <chrono>
#include <mutex>
TEST(ObjectAccessWrapper, Constructor)
{
    ObjectAccessWrapper<int, 4> obj_wrapper;
    int obj = 12;
    auto reservation = obj_wrapper.GetTmpObject(1, obj);

    EXPECT_EQ(&reservation.obj, &obj);
    EXPECT_NE(&obj_wrapper.GetTmpObject(1, obj).obj, &obj);
    EXPECT_NE(&obj_wrapper.GetTmpObject(2, obj).obj, &obj);

    obj_wrapper.ReturnTmpObject(reservation);
    EXPECT_EQ(&obj_wrapper.GetTmpObject(3, obj).obj, &obj);
}
#endif

TEST(ObjectAccessWrapper, TimeMeasurment)
{
#if 0
    unsigned int loops = 1000 * 1000;
    int obj = 12;
    ObjectAccessWrapper<int, 4> obj_wrapper2;
    std::chrono::high_resolution_clock::time_point t1 = std::chrono::high_resolution_clock::now();
    for (int i = 0; i < loops; ++i)
    {
        auto test = obj_wrapper2.GetTmpObject(1, obj);
        obj_wrapper2.ReturnTmpObject(test);
    }
    std::chrono::high_resolution_clock::time_point t2 = std::chrono::high_resolution_clock::now();
    std::cout << "Access original Object \t"
              << std::chrono::duration_cast<std::chrono::nanoseconds>(t2 - t1).count() << "ns for "
              << loops << " for single access "
              << std::chrono::duration_cast<std::chrono::nanoseconds>(t2 - t1).count() / loops
              << std::endl;

    auto test2 = obj_wrapper2.GetTmpObject(2, obj);

    t1 = std::chrono::high_resolution_clock::now();
    for (int i = 0; i < loops; ++i)
    {
        auto test = obj_wrapper2.GetTmpObject(1, obj);
        obj_wrapper2.ReturnTmpObject(test);
    }
    t2 = std::chrono::high_resolution_clock::now();
    std::cout << "Access temp Object \t"
              << std::chrono::duration_cast<std::chrono::nanoseconds>(t2 - t1).count() << "ns for "
              << loops << " for single access "
              << std::chrono::duration_cast<std::chrono::nanoseconds>(t2 - t1).count() / loops
              << std::endl;

    std::mutex mutex;
    t1 = std::chrono::high_resolution_clock::now();
    for (int i = 0; i < loops; ++i)
    {
        mutex.lock();
        mutex.unlock();
    }

    t2 = std::chrono::high_resolution_clock::now();
    std::cout << "Lock/Unlock mutex \t"
              << std::chrono::duration_cast<std::chrono::nanoseconds>(t2 - t1).count() << "ns for "
              << loops << " for single access "
              << std::chrono::duration_cast<std::chrono::nanoseconds>(t2 - t1).count() / loops
              << std::endl;

    auto test = obj_wrapper2.GetTmpObject(1, obj);
    t1 = std::chrono::high_resolution_clock::now();
    for (int i = 0; i < loops; ++i)
    {
        obj_wrapper2.ReturnTmpObject(test);
    }
    t2 = std::chrono::high_resolution_clock::now();
    std::cout << "Return temp object \t"
              << std::chrono::duration_cast<std::chrono::nanoseconds>(t2 - t1).count() << "ns for "
              << loops << " for single access "
              << std::chrono::duration_cast<std::chrono::nanoseconds>(t2 - t1).count() / loops
              << std::endl;

#endif
}
