#include <gtest/gtest.h>

#include "parallelization/LoadBalancerHelper.hpp"

using namespace load_balancer::details;

TEST(EqualDist, basic_block_id_check)
{
    EqualDist dist(10, 2);

    EXPECT_EQ(dist.GetBlockId(0), 0);
    EXPECT_EQ(dist.GetBlockId(1), 0);
    EXPECT_EQ(dist.GetBlockId(2), 0);
    EXPECT_EQ(dist.GetBlockId(3), 0);
    EXPECT_EQ(dist.GetBlockId(4), 0);

    EXPECT_EQ(dist.GetBlockId(5), 1);
    EXPECT_EQ(dist.GetBlockId(6), 1);
    EXPECT_EQ(dist.GetBlockId(7), 1);
    EXPECT_EQ(dist.GetBlockId(8), 1);
    EXPECT_EQ(dist.GetBlockId(9), 1);

    EqualDist dist2(11, 2);

    EXPECT_EQ(dist2.GetBlockId(0), 0);
    EXPECT_EQ(dist2.GetBlockId(1), 0);
    EXPECT_EQ(dist2.GetBlockId(2), 0);
    EXPECT_EQ(dist2.GetBlockId(3), 0);
    EXPECT_EQ(dist2.GetBlockId(4), 0);
    EXPECT_EQ(dist2.GetBlockId(5), 0);

    EXPECT_EQ(dist2.GetBlockId(6), 1);
    EXPECT_EQ(dist2.GetBlockId(7), 1);
    EXPECT_EQ(dist2.GetBlockId(8), 1);
    EXPECT_EQ(dist2.GetBlockId(9), 1);
    EXPECT_EQ(dist2.GetBlockId(10), 1);

    auto bs_vec = dist.GetBSVector();
    for (auto bs : bs_vec)
        EXPECT_EQ(bs, 5);

    auto bs_vec2 = dist2.GetBSVector();
    EXPECT_EQ(bs_vec2[0], 6);
    EXPECT_EQ(bs_vec2[1], 5);
}
