/*
 * This file is part of FMSOLVR, a Fast Multipole Solver for MD.
 *
 * Copyright © 2019 Andreas Beckmann
 *
 * FMSOLVR is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 2.1
 * of the License, or (at your option) any later version.
 *
 * FMSOLVR is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with FMSOLVR.  If not, see
 * <https://www.gnu.org/licenses/>.
 */
#ifndef _AnBe_FMM_unittests__rotation_testhelpers_hpp_
#define _AnBe_FMM_unittests__rotation_testhelpers_hpp_

#include "simd_real_testhelpers.hpp"
#include "fmsolvr/multipole.hpp"
#include "fmsolvr/operator/rotation/rotation_types.hpp"


namespace  // anonymous namespace
{

template <template <typename...> class CoefficientMatrix>
struct test_triangle_type
{
    template <
            typename Real,
            template <typename> class SIMDengine,
            typename Functor,
            typename... Args>
    void operator()(Functor f, Args... args)
    {
        typedef fmsolvr::RotationDataTypes<Real> RotationDataTypes;
        typedef CoefficientMatrix<Real> CoeffMatrix;
        f.template operator()<RotationDataTypes, CoeffMatrix, SIMDengine>(args...);
    }
};

template <typename Functor, typename... Args>
void test_all_triangle_types(Functor f, Args... args)
{
    test_all_real_types(test_triangle_type<fmsolvr::MultipoleCoefficientsUpper>(), f, args...);
    test_all_real_types(test_triangle_type<fmsolvr::MultipoleCoefficientsUpperLower>(), f, args...);
}

}  // anonymous namespace

#endif
// vim: et:ts=4:sw=4
